-- Weapons for Type 055 Destroyer by Currenthill

-- =============================== HHQ-10 short range SAM  ==========================================

local name_HHQ_10 = 'HHQ-10'
TYPE_055_HHQ_10 = {
    category        = CAT_MISSILES,
    name            = name_HHQ_10,
    user_name       = _("HHQ-10"),
    model           = 'Type055_HHQ-10',
    mass            = 30.0,
    wsTypeOfWeapon  = {4,4,34,WSTYPE_PLACEHOLDER},

    Escort       = 3,
    Head_Type    = 8,
    sigma        = {3, 3, 3}, --aiming error on target
    M            = 20.0, --missile mass in KG
    H_max        = 6000.0, --maximum flight altitude
    H_min        = 1.5,  --minimum flight altitude
    Diam         = 127.0, --diameter
    Cx_pil       = 1,
    D_max        = 6000.0,  -- maximum launch range at 0 height
    D_min        = 500.0, --minimum launch range
    Head_Form    = 0,
    Life_Time    = 15.0,
    Nr_max       = 20,
    v_min        = 150.0, --minimum speed
    v_mid        = 1000.0, --average speed
    Mach_max     = 4.5,
    t_b          = 0.0, --engine start delay time
    t_acc        = 0.0, --engine operating time
    t_marsh      = 12.0, --time in flight
    Range_max    = 9000.0, -- maximum launch range at maximum height (HHQ9: 100km range)
    H_min_t      = 1.5, --minimum target height
    Fi_start     = 3.14152, -- angle of tracking at firing
    Fi_rak       = 3.14152,
    Fi_excort    = 2.0,
    Fi_search    = 99.9, --search angle limit
    OmViz_max    = 99.9, --search line speed limit
	exhaust 	 = { 1.0, 1.0, 1.0, 0.5 },
    X_back       = -2.10,
    Y_back       = 0.0,
    Z_back       = 0.0,
	X_back_acc 	 = -2.10,
    Y_back_acc 	 = 0.0,
    Z_back_acc 	 = 0.0,	
	tail_scale 	 = 0.03,	
    Reflection   = 0.01, --effective surface of radio reflection, square meters (like 5V55)
    KillDistance = 5.0,
    ccm_k0       = 0.0,

	warhead = enhanced_a2a_warhead(3),

    shape_table_data = {
        {
            name     = name_HHQ_10,
            file     = 'Type055_HHQ-10',
            life     = 1,
            fire     = {0, 1},
            username = _("HHQ-10"),
            index    = WSTYPE_PLACEHOLDER,
        },
    },

		ModelData = {   58 ,  -- model params count
						0.05 ,   -- characteristic square (характеристическая площадь)
						
						-- параметры зависимости Сx
						0.1 , -- Cx_k0 планка Сx0 на дозвуке ( M << 1)
						0.1 , -- Cx_k1 высота пика волнового кризиса
						0.02 , -- Cx_k2 крутизна фронта на подходе к волновому кризису
						0.06, -- Cx_k3 планка Cx0 на сверхзвуке ( M >> 1)
						1.2 , -- Cx_k4 крутизна спада за волновым кризисом 
						1.2 , -- коэффициент отвала поляры (пропорционально sqrt (M^2-1))
						
						-- параметры зависимости Cy
						0.8 , -- Cy_k0 планка Сy0 на дозвуке ( M << 1)
						0.8	 , -- Cy_k1 планка Cy0 на сверхзвуке ( M >> 1)
						1.2  , -- Cy_k2 крутизна спада(фронта) за волновым кризисом  
						
						0.8 , -- 7 Alfa_max  максимальный балансировачный угол, радианы
						0.0, --угловая скорость создаваймая моментом газовых рулей
						
					-- Engine data. Time, fuel flow, thrust.	
					--	t_statr		t_b		t_accel		t_march		t_inertial		t_break		t_end			-- Stage
						-1.0,		-1.0,	1.0,  		4.0,		0.0,			0.0,		1.0e9,         -- time of stage, sec
						 0.0,		0.0,	1.5,		1.5,		0.0,			0.0,		0.0,           -- fuel flow rate in second, kg/sec(секундный расход массы топлива кг/сек)
						 0.0,		0.0,	2500.0,	 2500.0,		0.0,			0.0,		0.0,           -- thrust, newtons
					
						 30.0, -- таймер самоликвидации, сек
						 60.0, -- время работы энергосистемы, сек
						 0, -- абсолютная высота самоликвидации, м
						 0.5, -- время задержки включения управления (маневр отлета, безопасности), сек
						 1.0e9, -- дальность до цели в момент пуска, при превышении которой ракета выполняется маневр "горка", м
						 1.0e9, -- дальность до цели, при которой маневр "горка" завершается и ракета переходит на чистую пропорциональную навигацию (должен быть больше или равен предыдущему параметру), м 
						 0.0,  -- синус угла возвышения траектории набора горки
						 30.0, -- продольное ускорения взведения взрывателя
						 30.0, -- модуль скорости сообщаймый катапультным устройством, вышибным зарядом и тд
						 1.19, -- характристика системы САУ-РАКЕТА,  коэф фильтра второго порядка K0
						 1.0, -- характристика системы САУ-РАКЕТА,  коэф фильтра второго порядка K1
						 3.0, -- характристика системы САУ-РАКЕТА,  полоса пропускания контура управления
						 0.0,
						 0.0,
						 0.0,
						 0.0,
						 0.0,
						 
						 0.0,
						 0.0,
						 0.0,
						 0.0, 
						 0.0,
						 0.0,
						0.0,
						0.0,
					},

}

declare_weapon(TYPE_055_HHQ_10)

GT_t.LN_t.Type055_HHQ10 = {}
GT_t.LN_t.Type055_HHQ10 = {}
GT_t.LN_t.Type055_HHQ10.type = 4
GT_t.LN_t.Type055_HHQ10.distanceMin = 500
GT_t.LN_t.Type055_HHQ10.distanceMax = 9000
GT_t.LN_t.Type055_HHQ10.reactionTime = 2;
GT_t.LN_t.Type055_HHQ10.launch_delay = 0.1;
GT_t.LN_t.Type055_HHQ10.reflection_limit = 0.02
GT_t.LN_t.Type055_HHQ10.ECM_K = -1
GT_t.LN_t.Type055_HHQ10.max_number_of_missiles_channels = 24
GT_t.LN_t.Type055_HHQ10.sensor = {}
set_recursive_metatable(GT_t.LN_t.Type055_HHQ10.sensor, GT_t.WSN_t[0])
GT_t.LN_t.Type055_HHQ10.external_tracking_awacs = false
GT_t.LN_t.Type055_HHQ10.show_external_missile = true
GT_t.LN_t.Type055_HHQ10.PL = {}
GT_t.LN_t.Type055_HHQ10.PL[1] = {}
GT_t.LN_t.Type055_HHQ10.PL[1].ammo_capacity = 24
GT_t.LN_t.Type055_HHQ10.PL[1].type_ammunition = TYPE_055_HHQ_10.wsTypeOfWeapon
GT_t.LN_t.Type055_HHQ10.PL[1].reload_time = 1000000; 
GT_t.LN_t.Type055_HHQ10.BR = { {pos = {0, 0, 0} } }
